<template>
  <div>
    <h1 class="text-center">Todo list</h1>
    <v-layout>
      <v-text-field
      v-model="newTaskName"
      text
      autofocus
      hide-details
      placeholder="E.g. Buy some milk"
      >
      </v-text-field>
      
      <v-btn
        id='addBtn'
        color="primary"
        @click="addTask()"
        >
        Add
      </v-btn>
    </v-layout> 

    <h2 class="ma-6" v-if="Tasks && Tasks.length > 0" > Here is the list of tasks </h2>
      <ul id="todo-list">
        <li is="task"
        v-for="task in Tasks" 
        :key="task.name"
        :injectedTaskName="task.name"
        remove-task="removeTask($event, task.name)"
        >
        </li>
      </ul> 
  </div>
</template>

<script>
import Task from '@/components/Task'
import * as apis from './../api/api'


export default {
  name: 'TaskList',
  data() {
      return {
        newTaskName: '',
        Tasks: [],
        size: 0,
        rawResponse: ''
      }
  },
  components: {
    Task
  },
  methods: {
    async addTask() {
      await apis.createTask(this.newTaskName)
      this.Tasks = await apis.fetchTasks()
    },
    removeTask(event, name) {
      var arr = []
      for (let i = 0; i < this.Tasks.length; i++) { 
        if (name === this.Tasks[i].name) {
          this.Tasks.splice(i--, 1)
        }
      }
    },
  },
  async created() {
    this.Tasks = await apis.fetchTasks();
  }
}
</script>
